#!/usr/bin/perl

#******************* 設定項目 **************************

$logfile='data.log';	#ログファイル

$passneed=1;		#ページを見るのに管理パスワードを入力するか(1:する 0:しない)
			#0にしたときはadmin.cgiにアクセスするとすぐに画面がでますので、
			#admin.cgiのファイル名は他人にアクセスされないようにわかりにくいものに
			#変更してください。
$passwd='admin';	#管理パスワード($passneedが1のときはここに設定したパスワードでログインします。)
$script='admin.cgi';	#このスクリプト

#******************* 設定はここまで *******************


if($passneed){
	&decode;
	if($FORM{'mode'} eq "view"){
		&View;
	}
	else{
		&Login;
	}
}
else{
	&View;

}

sub decode{
my(
@pairs,$name,$value,$buff
);
$buff=$ENV{'QUERY_STRING'};
if($buff){
	@pairs=split(/&/,$buff);
	foreach $pair (@pairs){
		($name,$value)=split(/=/,$pair);
		$value=~tr/+/ /;
		$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
		$value=~s/&/&amp;/g;
		$value=~s/</&lt;/g;
		$value=~s/>/&gt;/g;
		$value=~s/"/&quot;/g;
		$value=~s/'/&#039;/g;
		$value=~s/\x0D\x0A//g;
		$value=~s/\x0D//g;
		$value=~s/\x0A//g;
		$FORM{$name}=$value;
	}
}

}

sub checkpass{
if($_[0] ne $passwd){
	&error("パスワードが違います。");
}
}

sub Login{

&header;

print <<EOM;
<body>
<br>
<br>
<br>
<div align=center>
<form method="GET" action="$script">
<input type="hidden" name="mode" value="view">
<table>
<tr>
<td>パスワード</td><td><input type="password" name="pass" size=8 value=""></td>
</tr>
</table>
<br>
<input type="submit" value="ログイン">
</form>
</div>
</body>
</html>
EOM
exit;
}


sub View{
my(
$pid,$d,$dc_y,$dc_t,$hd
);

&checkpass($FORM{'pass'});

&header;

print <<EOM;
<body>
<table border="1" cellpadding="2" cellspacing="0">
<tr>
<td align="center" width="150">ページ</td><td align="center" width="60">昨日</td><td align="center" width="60">今日</td>
</tr>
EOM


unless(open(FILE,"$logfile")){
	&error("$logfileが開けません。");
}
$hd=<FILE>;
while(<FILE>){
	($pid,$dc_y,$dc_t)=split(/,/,$_);
	print "<tr>\n<td>$pid</td><td align=\"right\">$dc_y</td><td align=\"right\">$dc_t</td>\n</tr>\n";

}
close FILE;

print <<EOM;
</table>
</body>
</html>
EOM

exit;
}


sub header{
print <<EOM;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>PV</title>
<style type="text/css">
body{
font-family: "ＭＳ Ｐゴシック";
}
</style>
</head>
EOM
}

sub error{
&header;
print <<EOM;
<body>
<br>
<br>
<center>
ERROR<br><br>
EOM
print"※$_[0]\n";
print <<EOM;
<br><br>
</center>
</body>
</html>
EOM
exit;
}

